//
//  AuthNContext.m
//  AuthN
//
//  Created by CA Technologies
//  Copyright (c) 2012 CA Technologies. All rights reserved.
//

#import "AuthNContext.h"

@interface AuthNContext ()
- (void) addTheKey:(id)key andValue:(id)value toDictionary:(NSMutableDictionary *)theDict;
@end

@implementation AuthNContext
@synthesize authType = _authType;
@synthesize uid = _uid;
@synthesize pw = _pw;
@synthesize httpMethodOverride = _httpMethodOverride;
@synthesize headers = _headers;
@synthesize queryValues = _queryValues;
@synthesize body = _body;
@synthesize statusCode = _statusCode;
@synthesize urlStr = _urlStr;
@synthesize processCookies = _processCookies;
@synthesize successBlock = _successBlock;
@synthesize failureBlock = _failureBlock;

- (void) reset
{
    _authType = nil;
    _uid = nil;
    _pw = nil;
    _queryValues = nil;
    _headers = nil;
    _body = nil;
    _statusCode = 0;
    _urlStr = nil;
    _processCookies = NO;
    _successBlock = nil;
    _failureBlock = nil;
}

- (void) addToQueryValuesTheKey:(id)key andValue:(id)value {
    [self addTheKey:key andValue:value toDictionary:self.queryValues];
}

- (void) addToHeadersTheKey:(id)key andValue:(id)value {
    [self addTheKey:key andValue:value toDictionary:self.headers];
}

- (void) addTheKey:(id)key andValue:(id)value toDictionary:(NSMutableDictionary *)theDict {
    [theDict setObject:value forKey:key];
}

- (NSMutableDictionary *) queryValues {
    if (!_queryValues) {
        _queryValues = [[NSMutableDictionary alloc] init];
    }
    return _queryValues;
}

- (NSMutableDictionary *) headers {
    if (!_headers) {
        _headers = [[NSMutableDictionary alloc] init];
    }
    return _headers;
}

// if the uid & pw have been specified, and the authType has NOT been, then lets default to AUTH_BASIC
// if you want to place the username and pw in the queryParameters make sure to set this to AUTHN_AUTH_QUERY
- (NSString *) authType
{
    if (self.uid && self.pw && !_authType)
    {
        _authType = AUTHN_AUTH_BASIC;
    }
    return _authType;
}

- (NSString *) description
{
    NSString *desc = [[NSString alloc] initWithFormat:@"METHOD %@ STATUSCODE %i URL %@ QUERY %@ HEADERS %@ BODY %@",_httpMethodOverride, _statusCode,_urlStr,_queryValues, _headers,_body];
    return desc;
}

@end
