package com.example.smandroidauthn;


import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.webkit.CookieManager;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.Toast;

public class WvActivity extends Activity {
	

    protected CookieManager cookieManager = null;
    
    private AuthenticatedTask mAuthTask = null;
    private LogoutTask mLogoutTask = null;
    
	public WvActivity() {
		// TODO Auto-generated constructor stub
	}
    /** Called when the activity is first created. */
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.webview2);
        Bundle b = getIntent().getExtras();
        String url = b.getString("url");
        WebView wv = (WebView)findViewById(R.id.linweb);
        wv.setLayoutParams(wv.getLayoutParams());
        wv.setWebViewClient(new WebViewClient() {  
        	   @Override  
        	   public boolean shouldOverrideUrlLoading(WebView view, String url)  
        	   {  
        	       view.loadUrl(url);
        	       return false;

        	    }  
        	 });
        String ua = wv.getSettings().getUserAgentString() ;
        Log.d("AboutActivity", "UA = "+ua) ;
        
        cookieManager = CookieManager.getInstance();
        
        Log.d("smandroidauthn", "I have cookies:" +cookieManager.hasCookies());
        String cookie = cookieManager.getCookie("https://spstest.forwardinc.mobi");
        Log.d("smandroidauthn", "COOKIE!" + cookie);
        
        wv.loadUrl(url);

        Button lg = (Button) findViewById(R.id.wv_logout);
        lg.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
            	
            	mLogoutTask = new LogoutTask();
            	mLogoutTask.execute((Void)null);
            
            }
        });
        
        Button sessionCheck = (Button) findViewById(R.id.wv_session);
        sessionCheck.setOnClickListener(new View.OnClickListener(){

			@Override
			public void onClick(View v) {
				mAuthTask = new AuthenticatedTask();
				mAuthTask.execute((Void) null);
			}
        });
    }
    
    public void finishLogout(){
    	 Intent intent = new Intent();
         setResult(RESULT_OK, intent);
         finish();
    }
    
    public class LogoutTask extends AsyncTask<Void, Void, Boolean> {
    	Exception caughtException=null;
    	
    	@Override
    	protected Boolean doInBackground(Void... params){
    		AuthComm comm = new AuthComm(getSharedPreferences(ConfView.PREFERENCES_NS, Context.MODE_PRIVATE));
			try {
				return comm.logout();
			} catch(Exception e){
				caughtException=e;
				return false;
			}
    	}
    	
    	@Override
    	protected void onPostExecute(final Boolean success){
    		mLogoutTask = null;
    		Context context = getApplicationContext();
			Toast toast = null;
			if(success){
				toast = Toast.makeText(context,getString(R.string.successful_logout),Toast.LENGTH_SHORT);
			}else{
				if(caughtException!=null){
					toast = Toast.makeText(context, caughtException.getLocalizedMessage(),Toast.LENGTH_LONG);
				} else {
					toast = Toast.makeText(context,getString(R.string.not_successful_logout),Toast.LENGTH_SHORT);
				}
			}
			toast.show();
			finishLogout();
    	}
    	
    	protected void onCancelled(){
    		mLogoutTask = null;
		}
    }
    
    
    public class AuthenticatedTask extends AsyncTask<Void, Void, Boolean> {
    	Exception caughtException=null;
    	
		@Override
		protected Boolean doInBackground(Void... params) {
			AuthComm comm = new AuthComm(getSharedPreferences(ConfView.PREFERENCES_NS, Context.MODE_PRIVATE));
			try {
				return comm.isAuthenticated();
			} catch(Exception e){
				caughtException=e;
				return false;
			}
		}
		
		@Override
		protected void onPostExecute(final Boolean success){
			mAuthTask = null;
			Log.d("smandroidauthn", "In Post execute");
			Context context = getApplicationContext();
			Toast toast = null;
			if(success){
				toast = Toast.makeText(context,getString(R.string.authenticated),Toast.LENGTH_SHORT);
			}else{
				if(caughtException!=null){
					toast = Toast.makeText(context,caughtException.getLocalizedMessage(),Toast.LENGTH_LONG);
				} else {
					toast = Toast.makeText(context,getString(R.string.not_authenticated),Toast.LENGTH_SHORT);
				}
			}
			toast.show();
		}
		
		protected void onCancelled(){
			mAuthTask = null;
		}
    	
    }
    
}
